﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirBomber
{
    public class DrawningObject : IDrawningObject
    {
        private DrawningAirplane _airplane;

        public DrawningObject(DrawningAirplane airplane)
        {
            _airplane = airplane;
        }

        public float Step => _airplane?.Airplane?.Step ?? 0;

        public RectangleF GetCurrentPosition()
        {
            return _airplane.GetCurrentPosition();
        }

        public void MoveObject(Direction direction)
        {
            _airplane?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _airplane?.SetPosition(x, y, width, height);
        }

        public void DrawObject(Graphics g)
        {
            _airplane.DrawTransport(g);
        }

        /// <summary>
        /// Получения самолета из объекта отрисовки
        /// </summary>
        /// <param name="drawningObject">The drawning object.</param>
        /// <returns></returns>
        public static explicit operator DrawningAirplane(DrawningObject drawningObject) => drawningObject._airplane;
    }
}
