namespace AirBomber
{
    public partial class FormAirBomber : Form
    {
        private DrawningAirplane _airplane;


        /// <summary>
        ///  
        /// </summary>
        public DrawningObject SelectedAirplane { get; private set; }

        public FormAirBomber(DrawningAirplane? airplane = null)
        {
            _airplane = airplane;
            InitializeComponent();
            Draw();
        }
        /// <summary>
		///   
		/// </summary>
		private void Draw()
        {
            Bitmap bmp = new(pictureBoxCar.Width, pictureBoxCar.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _airplane?.DrawTransport(gr);
            
            pictureBoxCar.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            IAirplaneEngines? typeAirplaneEngines = null;
            switch (comboTypeEngines.Text)
            {
                case "":
                    typeAirplaneEngines = new AirplaneRectEngines();
                    break;
                case "":
                    typeAirplaneEngines = new AirplaneArrowEngines();
                    break;
                default:
                    typeAirplaneEngines = new DrawningAirplaneEngines();
                    break;
            }
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _airplane = new DrawningAirplane(rnd.Next(100, 300), rnd.Next(1000, 2000), color, typeAirplaneEngines);
            _airplane.DrawningEngines.CountEngines = (int)countEngineBox.Value;
            _airplane.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxCar.Width, pictureBoxCar.Height);
            toolStripStatusLabelSpeed.Text = $": {_airplane.Airplane.Speed}";
            toolStripStatusLabelWeight.Text = $": {_airplane.Airplane.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_airplane.Airplane.BodyColor.Name}";
            toolStripStatusCountEngines.Text = $" : {_airplane.DrawningEngines.CountEngines}";
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _airplane?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _airplane?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _airplane?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _airplane?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxCar_Resize(object sender, EventArgs e)
        {
            _airplane?.ChangeBorders(pictureBoxCar.Width, pictureBoxCar.Height);
            Draw();
        }

        private void buttonSelectAirplane_Click(object sender, EventArgs e)
        {
            SelectedAirplane = new(_airplane);
            DialogResult = DialogResult.OK;
        }
    }
}