﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirBomber
{
    public interface IAirplaneEngines
    {
        /// <summary>Получение действительного количества двигателей или установка поддерживаемого числа двигателей</summary>
        /// <value>The count engines.</value>
        int CountEngines { get; set; }

        /// <summary>Отрисовывает все двигатели на обеих крыльях</summary>
        /// <param name="g">The g.</param>
        /// <param name="colorEngine">Цвет двигателей.</param>
        /// <param name="wingPosX">Позиция крыльев по x. В этой координате будут центры двигателей</param>
        /// <param name="leftWingY">Крайняя левая позиция левого крыла по y</param>
        /// <param name="rightWingY">Крайняя правая позиция правого крыла по y</param>
        /// <param name="widthBodyAirplane">Ширина тела самолета, или расстояние между крыльями.</param>
        void DrawEngines(Graphics g, Color colorEngine, float wingPosX, float leftWingY, float rightWingY, int widthBodyAirplane);
    }
}
